#!/usr/bin/python3

from __future__ import print_function 
import argparse, sys, os, re
from urlparse import urlparse

"""
Resolves paths relative to input path (if not stdin).
This base path can be overridden with --cwd. 

"""
def localize_url (x, base):
    p = urlparse(x)
    if ':' in p.netloc:
        hostname, port = p.netloc.split(':', 1)
    else:
        hostname, port = p.netloc.strip(), None
    path = p.path.lstrip('/')
    path = re.sub(r"^p/", "etherdump/", path)
    path = os.path.join(base, path)
    return path
    # print ("URL", p, hostname, port)
    # ret = x.replace("http://etherbox.local/home/pi/", "")
    # ret = ret.replace("http://etherbox.lan/home/pi/", "")
    # return ret

include_pat = re.compile(r"^\s*\!\s*(http://(.+?))\s*$", re.M)

ap = argparse.ArgumentParser("")
ap.add_argument('--base', default="/home/pi")
ap.add_argument('infile', nargs='?', type=argparse.FileType('r'), default=sys.stdin)
ap.add_argument('outfile', nargs='?', type=argparse.FileType('w'), default=sys.stdout)
args = ap.parse_args()

# path = "."
# if args.infile.name != "<stdin>":
#     path, _ = os.path.split(args.infile.name)
# if args.cwd:
#     path = args.cwd

for line in args.infile:
    m = include_pat.search(line)
    if m:
        # print ("MATCH", m.groups(), file=sys.stderr)
        url = m.group(1)
        path = localize_url(url, args.base)
        print ("including contents of file {0}".format(path), file=sys.stderr)
        try:
            with open(path) as f:
                for line in f:
                    args.outfile.write(line)
                args.outfile.write("\n")
        except IOError as e:
            print (e, file=args.outfile)

    else:
        sys.stdout.write(line)

    # if line.startswith(args.include):
    #     filename = line.split()[1]
    #     filename = os.path.join(path, filename)
    #     if args.list:
    #         if os.path.exists(filename):
    #             print (filename, file=args.outfile)
    #     else:
    #         try:
    #             with open(filename) as f:
    #                 for line in f:
    #                     args.outfile.write(line)
    #                 args.outfile.write("\n")
    #         except IOError as e:
    #             print (e, file=args.outfile)
    # else:
    #     if not args.list:
    #         args.outfile.write(line)
